import TransactionService from './transaction.service'

export default {
  list (config) {
    const ta = [
      { name: 'cntl.mgr.list', old: { is_own: true } }, // Accounts
      { name: 'cntl.wapi_auth.list', join: { 0: 'api_fkey_cntl_wapi_auth_mgr' } }, // Tokens
      { name: 'cntl.mgr2role.list', join: { 0: 'api_fkey_cntl_mgr2role_mgr' } }, // Mgr2Role
      { name: 'cntl.role.list', old: { is_role: true, sorting_params_list: ['position'] } } // Roles
    ]
    return TransactionService.execute(config, ta)
  },
  update (config, { login_name_old, login_name_new, description_new, allow_data_manipulation_new, roles_to_add, roles_to_remove }) {
    const ta = [
      {
        name: 'cntl.mgr.update',
        new: {
          login_name: login_name_new,
          description: description_new,
          allow_data_manipulation: allow_data_manipulation_new
        },
        old: { login_name: login_name_old }
      },
      {
        name: 'cntl.mgr2role.bulk_update',
        new: { role_fq_name_list: roles_to_add },
        old: { role_fq_name_list: roles_to_remove, mgr_login_name: login_name_new }
      }
    ]
    return TransactionService.execute(config, ta)
  }
}
