import TransactionService from './transaction.service'

export default {
  getByParent(config, parent) {
    const ta = [
      { name: 'dns.fqdn.list', old: { value: parent } },
      { name: 'dns.fqdn.list', join: { 0: 'api_fkey_dns_fqdn_parent' } }
    ]
    return TransactionService.execute(config, ta)
  },
  getRecrodsByTargetFQDN(config, fqdn) {
    const ta = [
      { name: 'dns.fqdn.list', old: { value: fqdn } },
      { name: 'dns.record.list', join: { 0: 'api_fkey_dns_record_target_fqdn' } },
      { name: 'dnscfg.fqdn_type.list', old: { sorting_params_list: ['position'] } },
      { name: 'dnscfg.record_inttype.list', old: { is_own: true, sorting_params_list: ['record_type'] } }
    ]
    return TransactionService.execute(config, ta)
  },
  getRecordsByFQDN(config, fqdn) {
    const ta = [
      { name: 'dns.record.list', old: { fqdn_list: [fqdn], sorting_params_list: ['type', 'fqdn'] } },
      { name: 'dnscfg.fqdn_type.list', old: { sorting_params_list: ['position'] } },
      { name: 'dns.fqdn.list', old: { value: fqdn } },
      { name: 'dnscfg.record_inttype.list', old: { is_own: true, sorting_params_list: ['record_type'] } }
    ]
    return TransactionService.execute(config, ta)
  }
}
