import transactionutil from '@/util/transactionutil'

export default {
  dict_by_value_of_array (arr, val) {
    const res = {}
    for (let i = 0; i < arr.length; i++) {
      res[arr[i][val]] = arr[i]
    }
    return res
  },
  dict_of_lists_by_value_of_array (arr, val) {
    const res = {}
    for (let i = 0; i < arr.length; i++) {
      if (!(arr[i][val] in res)) {
        res[arr[i][val]] = []
      }
      res[arr[i][val]].push(arr[i])
    }
    return res
  },
  denullify_dict (dict) {
    const res = {}
    for (const key in dict) {
      if (dict[key] !== null) {
        res[key] = dict[key]
      }
    }
    return res
  },
  buildAPITaFromTaObjectArray (obj) {
    const res = []
    for (let i = 0; i < obj.length; i++) {
      const app = { name: `${obj[i].object_fq_name}.${obj[i].object_function}` }
      if (Object.keys(obj[i].parameters.old).length > 0) {
        app.old = obj[i].object_functions === null ? obj[i].parameters.old : transactionutil.filter_old_data(obj[i].object_functions[obj[i].object_function].parameters, obj[i].parameters.old)
      }
      if (Object.keys(obj[i].parameters.new).length > 0) {
        app.new = transactionutil.filter_unchanged_data(obj[i].parameters.new, obj[i].parameters.old)
      }
      res.push(app)
    }
    return res
  },
  getAPIErrorIndexFromDBException (e) {
    for (const t of e.traceback) {
      if ('param' in t && 'wapi.transaction_stmt.index' in t.param) {
        return t.param['wapi.transaction_stmt.index']
      }
    }
    return -1
  }
}
